unit MemForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    BtnCreateNil: TButton;
    BtnCreateOwner: TButton;
    BtnFreeLast: TButton;
    LblResult: TLabel;
    Btn100Strings: TButton;
    Bevel1: TBevel;
    BtnRefresh2: TButton;
    BtnSnap: TButton;
    SaveDialog1: TSaveDialog;
    procedure Button1Click(Sender: TObject);
    procedure BtnCreateNilClick(Sender: TObject);
    procedure BtnCreateOwnerClick(Sender: TObject);
    procedure BtnFreeLastClick(Sender: TObject);
    procedure Btn100StringsClick(Sender: TObject);
    procedure BtnRefresh2Click(Sender: TObject);
    procedure BtnSnapClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  public
    b: TButton;
    procedure Refresh2;
  end;

var
  Form1: TForm1;

implementation

uses
  DdhMMan, SnapForm;

{$R *.DFM}

procedure TForm1.Refresh2;
begin
  LblResult.Caption := Format (
    'Allocated: %d'#13'Free: %d'#13'Existing: %d'#13'Re-allocated %d',
    [GetMemCount, FreeMemCount,
    GetMemCount - FreeMemCount, ReallocMemCount]);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Refresh2;
end;

procedure TForm1.BtnCreateNilClick(Sender: TObject);
begin
  b := TButton.Create (nil);
  Refresh2;
end;

procedure TForm1.BtnCreateOwnerClick(Sender: TObject);
begin
  b := TButton.Create (self);
  Refresh2;
end;

procedure TForm1.BtnFreeLastClick(Sender: TObject);
begin
  if Assigned (b) then
  begin
    b.Free;
    b := nil;
  end;
  Refresh2;
end;

procedure TForm1.Btn100StringsClick(Sender: TObject);
var
  s1, s2: string;
  I: Integer;
begin
  s1 := 'hi';
  s2 := Btn100Strings.Caption;
  for I := 1 to 100 do
    s1 := s1 + ': hello world';
  Btn100Strings.Caption := s1;
  s1 := s2;
  Btn100Strings.Caption := s1;
  Refresh2;
end;

procedure TForm1.BtnRefresh2Click(Sender: TObject);
begin
  Refresh2;
end;

procedure TForm1.BtnSnapClick(Sender: TObject);
begin
  if SaveDialog1.Execute then
  begin
    SnapToFile (SaveDialog1.Filename);
    FormSnap.Memo1.Lines.LoadFromFile (
      SaveDialog1.Filename);
    FormSnap.Show;
  end;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  Refresh2;
end;

end.
